
#pragma once
#include <QObject>
#include <QAbstractItemModel>

struct TreeInterface;

class EventFilter : public QObject
{
	Q_OBJECT

protected:
	int (*fn)(QObject *obj, QEvent *event);
	
	virtual bool eventFilter(QObject *obj, QEvent *event) override;

public:
	EventFilter(int (*fn)(QObject *obj, QEvent *event));
};


class TreeModelBridge : public QAbstractItemModel
{
	Q_OBJECT

private:
	void*	receiver;
	TreeInterface*	interface;
	
public:
	explicit TreeModelBridge(void* _receiver, TreeInterface*	_interface);

	virtual QVariant	data	(const QModelIndex &index, int role) const override;
	virtual Qt::ItemFlags	flags	(const QModelIndex &index) const override;
	virtual QModelIndex	index	(int row, int column, const QModelIndex &parent = QModelIndex()) const override;
	virtual QModelIndex	parent	(const QModelIndex &index) const override;
	virtual int	rowCount	(const QModelIndex &parent = QModelIndex()) const override;
	virtual int	columnCount	(const QModelIndex &) const override;
	virtual bool	hasChildren	(const QModelIndex &parent = QModelIndex()) const override;

	void	beginReplace	(QModelIndex* parent, int first, int inserted, int deleted);
	void	endReplace	(QModelIndex* parent, int first, int inserted, int deleted);
};
